#include <vector>
#include <algorithm>
#include <iterator>
#include <iostream>
#include <ranges>

using namespace std;

auto sudost = [](int i) { return i % 2 == 0; };
auto tverec = [](int i) {return i * i; };

vector<int> jenSudNaDruhou(vector<int>& numera)
{
	vector<int> sudNumera;
	copy_if(begin(numera), end(numera), back_inserter(sudNumera), sudost);
	vector<int> vsledek;
	transform(begin(sudNumera), end(sudNumera), back_inserter(vsledek), tverec);
	return vsledek;
}

void vypi(ranges::range auto kontejner)
{
	for (auto i : kontejner)
	{
		cout << i << " ";
	}
	cout << endl;
}

auto jenSudNaDruhou1(vector<int>& numera)
{
	return numera | std::views::filter(sudost) | std::views::transform(tverec);
}

int main()
{
	vector<int> data{1, 4, 6, 7, 3, 9, 0, 8};
	vypi(jenSudNaDruhou(data));
	vypi(jenSudNaDruhou1(data));
	auto x = jenSudNaDruhou1(data);
	cout << typeid(x).name() << endl;
}