#include <ranges>
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <cctype>
#include <stdlib.h>
#include <string_view>

using namespace std;

int main()
{
	system("CHCP 1250 > NUL");
	// Vypoutme poten prvky vyhovujc dan podmnce (zde bl znaky)
	string zdroj = "  \t \t  \t    Nazdar, lidi"s;
	auto vsledek = ranges::drop_while_view{ zdroj, isspace };
	for (auto c : vsledek)
	{
		cout << c;
	}
	cout << endl;

	// Spojen rozsah
	vector<string> slova{"nazdar"s, " "s, "lidi"s, "!"s};
	ranges::join_view pozdrav{slova};
	for (auto c : pozdrav)
	{
		cout << c;
	}
	cout << endl;

	// Tot
	for (auto c : slova | views::join) cout << c;
	cout << endl;

	// Rozdlen rozsah
	string text = "luouk k pern pl belsk dy";
	ranges::split_view vta{text, ' '};
	for (auto slovo : vta)
	{
		for (char c : slovo) cout << c;
		cout << "*";
	}
	cout << endl;

	// Tot
	auto vsledek1 = text | views::split(' ');
	for (auto slovo : vta)
	{
		for (char c : slovo) cout << c;
		cout << "-";
	}
	cout << endl;

	// Obrcen pohled
	vector<int> cel_sla{0, 1, 2, 3, 4};
	ranges::reverse_view obrcen{cel_sla};
	for (int i : obrcen)cout << i << " ";
	cout << endl;

	// Nefunguje - nen default_initializable
	/*for (auto s : text | views::split(' ')) | views::reverse)
	{
		cout << s;
	}*/

	auto historick_osobnosti = map<string_view, int>
	{
		{"Lovelance"sv, 1815},
		{"Babbage", 1791},
		{"Turing"sv, 1912},
		{"Hamilton"sv, 1963}
	};
	//auto jmna = historick_osobnosti | views::elements<0>;
	//auto jmna = historick_osobnosti | views::keys;
	auto jmna = historick_osobnosti | views::values;
	for (auto&& jmno : jmna)
	{
		cout << jmno << " ";
	}
	cout << endl;
}